﻿//RIB_TabAct - Programm zum Aktivieren eines Ribbon-Tabs
//Verweise :acdbmgd.dll,acmgd.dll,AcWindows.dll,AdWindows.dll,
//          PresentationCore.dll,PresentationFramework.dll,System.dll,Sytem.Core.dll,WindowsBase.dll

using System;
using Autodesk.AutoCAD;
using Autodesk.Windows;
using Autodesk.AutoCAD.Ribbon;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using acadApp = Autodesk.AutoCAD.ApplicationServices.Application;

namespace RIB_TabAct
{
    //-----------------------------------------------------------------------------------
    public class RIB_TabAct
    {
        
        [CommandMethod("RibTabList", CommandFlags.Transparent)]
        public void TAB_LIST()
        {
            Autodesk.AutoCAD.Internal.Utils.TextScr(); //Textschirm aktivieren -> Variante ab ACA2010 : Application.DisplayTextScreen = true;
            try
            {
                Editor ED = Application.DocumentManager.MdiActiveDocument.Editor;
                RibbonControl ribbonControl = RibbonServices.RibbonPaletteSet.RibbonControl;
                RibbonTabCollection Tabs = ribbonControl.Tabs;
                foreach (RibbonTab TX_1 in Tabs)
                {
                    ED.WriteMessage("\nTABNAME: {0}", TX_1.Title);
                }
            }
            catch {}
        }
        //-----------------------------------------------------------------------------------
        [LispFunction("RibTabAct")]
        public static void RIBTABACT(ResultBuffer rbArgs)
        {
            Editor ED = acadApp.DocumentManager.MdiActiveDocument.Editor;
            if (rbArgs != null)
            {   string TAB_NAME = "";  int nCnt = 0;
                foreach (TypedValue rb in rbArgs)
                {
                    if (rb.TypeCode == (int)Autodesk.AutoCAD.Runtime.LispDataType.Text)
                    {
                        switch (nCnt)
                        {
                            case 0: TAB_NAME = rb.Value.ToString(); break;
                         }
                        nCnt = nCnt + 1;
                    }
                }
                ED.WriteMessage("\nAktiver Tabulator : " + TAB_NAME);
                try
                {
                    RibbonControl ribbonControl = RibbonServices.RibbonPaletteSet.RibbonControl;
                    RibbonTabCollection Tabs = ribbonControl.Tabs;
                    foreach (RibbonTab TAB in Tabs)
                    {
                        if (TAB.Title == TAB_NAME)
                        {
                            TAB.IsVisible = true;
                            ribbonControl.ActiveTab = TAB;
                        }
                    }
                    if (ribbonControl.ActiveTab.Title != TAB_NAME)
                    { ED.WriteMessage("\nDer TABULATOR wurde nicht gefunden : {0}", TAB_NAME); }
                }
                catch { }      
            }
        }
    }
}